<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('mall.userAccount')" prop="username">
        <el-input v-model="formData.username" :placeholder="t('mall.pleaseEnterUserAccount')" />
      </el-form-item>
      <el-form-item :label="t('mall.userNickname')" prop="nickname">
        <el-input v-model="formData.nickname" :placeholder="t('mall.pleaseEnterUserNickname')" />
      </el-form-item>
      <el-form-item :label="t('mall.phoneNumber')" prop="mobile">
        <el-input v-model="formData.mobile" :placeholder="t('mall.pleaseEnterPhoneNumber')" />
      </el-form-item>
      <el-form-item :label="t('mall.realName')" prop="realName">
        <el-input v-model="formData.realName" :placeholder="t('mall.pleaseEnterRealName')" />
      </el-form-item>
      <el-form-item :label="t('mall.birthday')" prop="birthday">
        <el-input v-model="formData.birthday" :placeholder="t('mall.pleaseEnterBirthday')" />
      </el-form-item>
      <el-form-item :label="t('mall.userRemark')" prop="mark">
        <el-input v-model="formData.mark" :placeholder="t('mall.pleaseEnterUserRemark')" />
      </el-form-item>
      <el-form-item :label="t('mall.userBalance')" prop="nowMoney">
        <el-input v-model="formData.nowMoney" :placeholder="t('mall.pleaseEnterUserBalance')" />
      </el-form-item>
      <el-form-item :label="t('mall.commissionAmount')" prop="brokeragePrice">
        <el-input v-model="formData.brokeragePrice" :placeholder="t('mall.pleaseEnterCommissionAmount')" />
      </el-form-item>
      <el-form-item :label="t('mall.userPoints')" prop="integral">
        <el-input v-model="formData.integral" :placeholder="t('mall.pleaseEnterUserRemainingPoints')" />
      </el-form-item>
      <!-- <el-form-item label="等级" prop="level">
        <el-input v-model="formData.level" placeholder="请输入等级" />
      </el-form-item> -->
      <!-- <el-form-item label="是否为推广员" prop="isPromoter">
        <el-input v-model="formData.isPromoter" placeholder="请输入是否为推广员" />
      </el-form-item> -->
      <el-form-item :label="t('mall.detailedAddress')" prop="addres">
        <el-input v-model="formData.addres" :placeholder="t('mall.pleaseEnterDetailedAddress')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{t('common.confirm')}}</el-button>
      <el-button @click="dialogVisible = false">{{t('common.cancel')}}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as UserApi from '@/api/member/user'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  username: undefined,
  password: undefined,
  realName: undefined,
  birthday: undefined,
  cardId: undefined,
  mark: undefined,
  partnerId: undefined,
  groupId: undefined,
  nickname: undefined,
  avatar: undefined,
  mobile: undefined,
  addIp: undefined,
  lastIp: undefined,
  nowMoney: undefined,
  brokeragePrice: undefined,
  integral: undefined,
  signNum: undefined,
  status: undefined,
  level: undefined,
  spreadUid: undefined,
  spreadTime: undefined,
  userType: undefined,
  isPromoter: undefined,
  payCount: undefined,
  spreadCount: undefined,
  addres: undefined,
  adminid: undefined,
  loginType: undefined,
  wxProfile: undefined
})
const formRules = reactive({
  username: [{ required: true, message: t('mall.userAccountCannotBeEmpty'), trigger: 'blur' }],
  nickname: [{ required: true, message: t('mall.userNicknameCannotBeEmpty'), trigger: 'blur' }],
  mobile: [{ required: true, message: t('mall.phoneNumberCannotBeEmpty'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await UserApi.getUser(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as UserApi.UserVO
    if (formType.value === 'create') {
      await UserApi.createUser(data)
      message.success(t('common.createSuccess'))
    } else {
      await UserApi.updateUser(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    username: undefined,
    password: undefined,
    realName: undefined,
    birthday: undefined,
    cardId: undefined,
    mark: undefined,
    partnerId: undefined,
    groupId: undefined,
    nickname: undefined,
    avatar: undefined,
    mobile: undefined,
    addIp: undefined,
    lastIp: undefined,
    nowMoney: undefined,
    brokeragePrice: undefined,
    integral: undefined,
    signNum: undefined,
    status: undefined,
    level: undefined,
    spreadUid: undefined,
    spreadTime: undefined,
    userType: undefined,
    isPromoter: undefined,
    payCount: undefined,
    spreadCount: undefined,
    addres: undefined,
    adminid: undefined,
    loginType: undefined,
    wxProfile: undefined
  }
  formRef.value?.resetFields()
}
</script>
